import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter_easyrefresh/easy_refresh.dart';
import 'package:flutter_mylibrary/base/provider/view_state_model.dart';
import 'package:flutter_mylibrary/config/const.dart';

Widget getNoDataWidget({String error = 'No Data'}) => Align(
  alignment: Alignment.center,
  child: Column(
    mainAxisAlignment: MainAxisAlignment.center,
    crossAxisAlignment: CrossAxisAlignment.center,
    children: <Widget>[
      Expanded(
        child: SizedBox(),
        flex: 2,
      ),
      SizedBox(
          width: 100.0,
          height: 100.0,
          child: Image.asset('assets/images/nodata.png')
      ),
      Text(
        error,
        style: TextStyle(fontSize: 16.0, color: Colors.grey[400]),
      ),
      Expanded(
        child: SizedBox(),
        flex: 3,
      ),
    ],
  ),
);


Widget getViewStateWidget(ViewStateModel provider, Function idleWdiget, {Widget busyWidget}){
  if(provider.isIdle){
    return idleWdiget();
  }else if(provider.isError){
    return getNoDataWidget(error: provider.viewStateError.message);
  }else if(provider.isEmpty){
    return getNoDataWidget();
  }else if (provider.isBusy) {
    return busyWidget??pageLoading;
  } else{
    return Container();
  }
}

Widget getRefreshNoDataWidget({ViewStateModel viewStateModel, Widget busyWidget}){
  if(viewStateModel.isError){
    return getNoDataWidget(error: viewStateModel.viewStateError.message);
  }else if(viewStateModel.isEmpty){
    return getNoDataWidget();
  }else if (viewStateModel.isBusy) {
    return busyWidget??pageLoading;
  }else{
    return null;
  }
}


